/*

  Copyright (c) 2003,2004 uim Project http://uim.freedesktop.org/

  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  3. Neither the name of authors nor the names of its contributors
     may be used to endorse or promote products derived from this software
     without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

*/

/*
 * ץꥨǥåȤ䥹ơ饤褹
 */
#if HAVE_CONFIG_H
#include "config.h"
#endif
#if HAVE_STRING_H
#include <string.h>
#endif
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#if HAVE_STDLIB_H
#include <stdlib.h>
#endif
#if HAVE_ASSERT_H
#include <assert.h>
#endif

extern int s_save_cursor;

#define WINNOSIZE 5
#define MODESIZE 50

#include "uim-fep.h"
#include "callbacks.h"
#include "escseq.h"
#include "draw.h"
#include "str.h"
#include "udsock.h"

/* ߤΥץꥨǥå Хѿ */
struct preedit_tag *s_preedit;
/* ߥåȤƤϤޤTRUE */
int g_commit = FALSE;

/* s_preedit->width > 0Ʊ */
int g_start_preedit = FALSE;
/* ߥåȤ줿ȤΥץꥨǥåȤ¸ */
static struct preedit_tag s_save_preedit;
/* ץꥨǥåȤƬΰ */
static struct point_tag s_head;
/* Կ -> ԤƬʸ1ʸޤǤΥץꥨǥåȤ */
static int *s_line2width = NULL;
/* ץꥨǥåȤιԿ */
static int s_preedit_lines = 0;

static uim_context s_context;
/* ơ饤μ */
static int s_status;
/* üޥΥե뵭һ */
static int s_master;
/* ⡼ɾʸ */
static char s_modebuf[MODESIZE];
/*  */
static char s_candbuf[CANDSIZE];
/* GNU screenWINDOWֹ */
static char s_win_no[WINNOSIZE];
/* ⡼ɾ֤񤭹ե */
static const char *s_path_getmode;
/* üѴȤTRUE */
static int s_winch = FALSE;
static int s_scroll = 0;

static void init_backtick(void);
static void update_backtick(void);
static void start_preedit(void);
static void end_preedit(void);
static void draw_statusline(int force, int restore, int visible);
static void draw_preedit(struct preedit_tag *preedit, struct preedit_tag *prev_preedit);
static void draw_subpreedit(struct preedit_tag *p, int start, int end);
static void draw_pseg(struct preedit_segment_tag *pseg, int start_width);
static void change_attr(int attr);
static int compare_preedit(struct preedit_tag *p1, struct preedit_tag *p2);
static int compare_preedit_rev(struct preedit_tag *p1, struct preedit_tag *p2);
static int min(int a, int b);
static void erase_preedit(struct preedit_tag *p);
static void erase_area(struct point_tag start, struct point_tag end);
static void goto_char(int width);
static void goto_col(int width);
static struct point_tag width2point_char(int width);
static struct point_tag width2point_col(int width);
static int width2lineno_char(int width);
static int width2lineno_col(int width);

#if DEBUG > 2
static void print_preedit(struct preedit_tag *p);
#endif

/*
 * init_escseqinit_callbacksθ˸ƤФ
 */
void init_draw(uim_context context, int statusline_type, int master, const char *path_getmode)
{
  s_context = context;
  s_status = statusline_type;
  s_master = master;
  s_path_getmode = path_getmode;
  s_preedit = create_preedit();
  if (s_status == BACKTICK) {
    draw_statusline_no_restore();
    init_backtick();
  }
}

static void init_backtick()
{
  if (getenv("WINDOW")) {
    snprintf(s_win_no, sizeof(s_win_no), "%s ", getenv("WINDOW"));
  }
  update_backtick();
}

static void update_backtick()
{
  char sendbuf[CANDSIZE];
  if (s_candbuf[0] == '\0') {
    /* ⡼ɽ */
    sprintf(sendbuf, "[%s%s]", s_win_no, s_modebuf);
  } else {
    /* ɽ */
    sprintf(sendbuf, "%s", s_candbuf);
  }
  sendline(sendbuf);
}

/*
 * ץꥨǥåȡơ饤褹
 */
void draw()
{
  char *commit_str;

  struct preedit_tag *prev_preedit;

  /* üѹ줿Ȥs_headѹ */
  if (s_winch && g_start_preedit) {
    /* üѹΥ */
    struct point_tag cursor = width2point_char(s_preedit->cursor);
    /* ץꥨǥåƬа */
    int diff_row = cursor.row - s_head.row;
    int diff_col = cursor.col - s_head.col;
    /* s_headѹ */
    s_head = get_cursor_position();
    s_head.row -= diff_row;
    s_head.col -= diff_col;
    /* s_head̤Фʤ褦˽ */
    if (s_head.row < 0) {
      s_head.row = 0;
    } else if (s_head.row > g_win->ws_row - 1) {
      s_head.row = g_win->ws_row - 1;
    }
    if (s_head.col < 0) {
      s_head.col = 0;
    } else if (s_head.col > g_win->ws_col - 1) {
      s_head.col = g_win->ws_col - 1;
    }
  }

  prev_preedit = s_preedit;
  s_preedit = get_preedit();
  commit_str = get_commit_str();

  debug(("draw()\n"));
  debug2(("commit_str = \"%s\"\n", commit_str));
  debug2(("preedit->width = %d\n", s_preedit->width));

  /* ¸ƤץꥨǥåȤϤ⤦ʤ */
  s_save_preedit.width = 0;

  /* ץꥨǥåȤ̵Х᤹ */
  draw_statusline(FALSE, !g_start_preedit, FALSE);

  /* ߥåȤ줿 */
  if (commit_str[0] != '\0') {
    g_commit = TRUE;
    /* ץꥨǥåȤäɬפ뤫 */
    if (prev_preedit->width > 0) {
      put_exit_attribute_mode();
      put_cursor_invisible();
      erase_preedit(prev_preedit);
      end_preedit();
    }
    write(s_master, commit_str, strlen(commit_str));
  }
  if (!g_commit) {
    /* ޤϾõץꥨǥåȤ뤫 */
    if (s_preedit->width != 0 || prev_preedit->width != 0) {
      if (prev_preedit->width == 0) {
        start_preedit();
      }
      put_exit_attribute_mode();
      draw_preedit(s_preedit, prev_preedit);
      if (s_preedit->width == 0) {
        end_preedit();
      }
    }
  } else {
    if (s_preedit->width > 0) {
      /* ߥåȤ줿Ȥ˥ץꥨǥåȤäΤǡ夫Ϥ
       * 뤿˥ץꥨǥåȤ¸  */
      s_save_preedit = *s_preedit;
    }
    s_preedit->width = s_preedit->cursor = s_preedit->nr_psegs = 0;
  }

  free_preedit(prev_preedit);
  free(commit_str);
  put_cursor_normal();
  s_winch = FALSE;

  debug(("\ndraw end\n"));
}

/*
 * ץꥨǥåȤ򳫻ϤȤ˸Ƥ
 */
static void start_preedit()
{
  if (!g_start_preedit) {
    debug2(("start_preedit()\n"));
    s_head = get_cursor_position();
    if (s_head.col == g_win->ws_col - 1) {
      s_head.col = 0;
      if (s_head.row == g_win->ws_row - 1) {
        put_crlf();
      } else {
        s_head.row++;
      }
    }
    debug2(("s_head.row = %d s_head.col = %d\n", s_head.row, s_head.col));
    s_line2width = malloc(sizeof(int));
    s_line2width[0] = -s_head.col;
    s_preedit_lines = 1;
    g_start_preedit = TRUE;
  }
}

/*
 * ץꥨǥåȤλȤ˸Ƥ
 * ϥץꥨǥåȳϰ֤˰ư
 */
static void end_preedit()
{
  g_start_preedit = FALSE;
  put_cursor_address_p(&s_head);
  s_preedit_lines = 0;
  if (s_line2width != NULL) {
    free(s_line2width);
    s_line2width = NULL;
  }
  debug2(("end_preedit()\n"));
}

/*
 * ߥåȤȥץꥨǥåȤƱȯ
 * θ塤ߥåȤϤȤTRUE֤
 */
int is_commit_and_preedit(void)
{
  return !g_commit && s_save_preedit.width > 0;
}

/*
 * is_commit_and_preedit() == TRUEΤȤ˸ƤФ졤
 * ץꥨǥåȤϤ
 */
void draw_commit_and_preedit(void)
{
  assert(is_commit_and_preedit());
  assert(s_preedit->width == 0);
  *s_preedit = s_save_preedit;
  s_save_preedit.width = 0;
  s_save_preedit.cursor = 0;
  s_save_preedit.nr_psegs = 0;
  start_preedit();
  put_exit_attribute_mode();
  /* prev_preedit϶ */
  draw_preedit(s_preedit, &s_save_preedit);
}

/*
 * ơ饤褹
 * forceTRUEΤȤϾ֤ѤäƤʤƤ褹
 * restoreTRUEΤȤϥ򳫻ϰ֤᤹
 * visibleTRUEΤȤϽλ˥ɽ
 */
static void draw_statusline(int force, int restore, int visible)
{
  static char *statusline_str = NULL;
  static char *candidate_str = NULL;
  static int candidate_col = UNDEFINED;
  static int mode = UNDEFINED;
  static int mode_width = 0;
  static char *index_str = NULL;
  static int index_col = UNDEFINED;

  const char *mode_str;

  char *prev_statusline_str;
  char *prev_candidate_str;
  int prev_candidate_col;
  int prev_mode;
  int prev_mode_width;
  char *prev_index_str;
  int prev_index_col;

  /* staticѿν 1󤷤¹Ԥʤ */
  if (statusline_str == NULL) {
    statusline_str = strdup("");
  }
  if (candidate_str == NULL) {
    candidate_str = strdup("");
  }
  if (index_str == NULL) {
    index_str = strdup("");
  }

  prev_statusline_str = statusline_str;
  prev_candidate_str = candidate_str;
  prev_candidate_col = candidate_col;
  prev_mode = mode;
  prev_mode_width = mode_width;
  prev_index_str = index_str;
  prev_index_col = index_col;

  statusline_str = get_statusline_str();
  candidate_str = get_candidate_str();
  candidate_col = get_candidate_col();
  mode = get_mode();
  index_str = get_index_str();
  index_col = get_index_col();

  debug2(("draw_statusline()\n"));
  debug2(("statusline_str = \"%s\"\n", statusline_str));
  debug2(("candidate_str = \"%s\"\n", candidate_str));
  debug2(("candidate_col = %d\n", candidate_col));
  debug2(("prev_mode = %d\n", prev_mode));
  debug2(("mode = %d\n", mode));
  debug2(("index_str = \"%s\"\n", index_str));
  debug2(("index_col = %d\n", index_col));

  /* õ */
  if (statusline_str[0] == '\0' && prev_statusline_str[0] != '\0') {
    if (s_status == LASTLINE) {
      if (restore) {
        put_save_cursor();
      }
      put_cursor_invisible();
      put_goto_lastline(0);
      put_clear_to_end_of_line();
      /* äϥ⡼ɤ褹ɬפ */
      force = TRUE;
    } else if (s_status == BACKTICK) {
      s_candbuf[0] = '\0';
    }
  } else {
    /*  */ 
    if (strcmp(statusline_str, prev_statusline_str) != 0 || (force && statusline_str[0] != '\0')) {
      /* ʤΤθϤʤ */
      prev_candidate_col = UNDEFINED;
      prev_index_col = UNDEFINED;
      if (s_status == LASTLINE) {
        if (restore) {
          put_save_cursor();
        }
        put_cursor_invisible();
        put_exit_attribute_mode();
        put_exit_standout_mode();
        put_exit_underline_mode();
        put_goto_lastline(0);
        /* 䤬򤵤Ƥ뤫 */
        if (candidate_col != UNDEFINED) {
          int byte_cand = (width2byte(statusline_str, candidate_col))[0];
          int byte_index = (width2byte(statusline_str, index_col))[0];
          put_str_len(statusline_str, byte_cand);
          put_enter_standout_mode();
          put_str(candidate_str);
          put_exit_standout_mode();
          put_str_len(statusline_str + byte_cand + strlen(candidate_str), byte_index - byte_cand - strlen(candidate_str));
          assert(index_col != UNDEFINED);
          put_str(index_str);
          put_str(statusline_str + byte_index + strlen(index_str));
        } else {
          put_str(statusline_str);
        }
        if (strwidth(statusline_str) < strwidth(prev_statusline_str)) {
          put_clear_to_end_of_line();
        }
        goto end_candidate;
      } else if (s_status == BACKTICK) {
        strncpy(s_candbuf, statusline_str, CANDSIZE - 1);
      }
    }
    if (prev_candidate_col != candidate_col) {
      /* θȿž᤹ */
      if (prev_candidate_col != UNDEFINED) {
        if (s_status == LASTLINE) {
          if (restore) {
            put_save_cursor();
          }
          put_cursor_invisible();
          put_exit_attribute_mode();
          put_exit_standout_mode();
          put_exit_underline_mode();
          put_goto_lastline(prev_candidate_col);
          put_str(prev_candidate_str);
        }
      }
      /* 򤵤줿ȿž */
      if (candidate_col != UNDEFINED) {
        if (s_status == LASTLINE) {
          if (restore) {
            put_save_cursor();
          }
          put_cursor_invisible();
          put_exit_attribute_mode();
          put_exit_underline_mode();
          put_enter_standout_mode();
          put_goto_lastline(candidate_col);
          put_str(candidate_str);
        } else if (s_status == BACKTICK) {
          int byte;
          strncpy(s_candbuf, statusline_str, CANDSIZE - 1);
          byte = (width2byte(statusline_str, candidate_col))[0] + strlen(candidate_str);
          if (0 <= byte && byte <= CANDSIZE - 1) {
            s_candbuf[byte] = ']';
          }
          byte -= (strlen(candidate_str) + 1);
          if (0 <= byte && byte <= CANDSIZE - 1) {
            s_candbuf[byte] = '[';
          }
        }
      }
    }
    if (index_col != UNDEFINED) {
      if (s_status == LASTLINE) {
        int i = 0;
        if (restore) {
          put_save_cursor();
        }
        put_cursor_invisible();
        put_exit_attribute_mode();
        put_exit_underline_mode();
        put_exit_standout_mode();
        /* index_strascii */
        if (prev_index_col != UNDEFINED) {
          for (i = 0; i < (int)strlen(index_str); i++) {
            if (index_str[i] != prev_index_str[i]) {
              break;
            }
          }
        }
        if (i < (int)strlen(index_str)) {
          put_goto_lastline(index_col + i);
          put_str(index_str + i);
        }
      } else if (s_status == BACKTICK) {
        memcpy(s_candbuf + (width2byte(statusline_str, index_col))[0], index_str, strlen(index_str));
      }
    }
  }
end_candidate:

  if (force || mode != prev_mode) {

    /* ߤΥ⡼ɤUIM_FEP_SETMODE˽񤭹 */
    if (s_path_getmode[0] != '\0') {
      FILE *fp = fopen(s_path_getmode, "wt");
      if (fp) {
        fprintf(fp, "%d\n", mode);
        fclose(fp);
      }
    }

    if (s_status != NONE && statusline_str[0] == '\0') {
      mode_str = uim_get_mode_name(s_context, mode);
      if (s_status == LASTLINE) {
        if (restore) {
          put_save_cursor();
        }
        put_cursor_invisible();
        put_goto_lastline(0);
        put_exit_attribute_mode();
        put_exit_standout_mode();
        put_exit_underline_mode();
        put_str(mode_str);
        mode_width = strwidth(mode_str);
        if (prev_mode_width > mode_width) {
          put_clear_to_end_of_line();
        }
      } else if (s_status == BACKTICK) {
        strncpy(s_modebuf, mode_str, MODESIZE - 1);
      }
    }
  }
  free(prev_candidate_str);
  free(prev_statusline_str);
  free(prev_index_str);
  if (restore) {
    put_restore_cursor();
  }
  if (s_status == BACKTICK) {
    update_backtick();
  }
  if (visible) {
    put_cursor_normal();
  }
  debug2(("<end draw statusline>\n"));
}

/*
 * ơ饤Υ⡼ɽmodeˤ
 * ֤Ѥʤ
 */
void draw_statusline_restore(void)
{
  draw_statusline(FALSE, TRUE, TRUE);
}

/*
 * ơ饤Υ⡼ɽmodeˤ
 * ϺǲԤ˰ư
 */
void draw_statusline_no_restore(void)
{
  draw_statusline(FALSE, FALSE, FALSE);
}

/*
 * ǲԤ褹
 * ϺǲԤ˰ư
 */
void draw_statusline_force_no_restore(void)
{
  assert(s_status == LASTLINE);
  draw_statusline(TRUE, FALSE, FALSE);
}

/*
 * ǲԤ褹
 * ֤Ѥʤ
 */
void draw_statusline_force_restore(void)
{
  assert(s_status == LASTLINE);
  draw_statusline(TRUE, TRUE, TRUE);
}

/*
 * ǲԤä
 * ϺǲԤ˰ư
 */
void clear_lastline(void)
{
  assert(s_status == LASTLINE);
  put_exit_attribute_mode();
  put_goto_lastline(0);
  put_clear_to_end_of_line();
}

/*
 * backtickä
 */
void clear_backtick(void)
{
  assert(s_status == BACKTICK);
  sendline("");
}

/*
 * ץꥨǥåȤ褹
 * ϻΥ֤Ǥ
 * λΥ֤preedit->cursor
 */
static void draw_preedit(struct preedit_tag *preedit, struct preedit_tag *prev_preedit)
{
  int eq_width;
  struct point_tag end_point;
  struct point_tag prev_end_point;

  /* üѹ줿Ȥprev_preedit̵뤹 */
  eq_width = s_winch ? 0 : compare_preedit(preedit, prev_preedit);

#if DEBUG > 2
  debug2(("\neq_width = %d\n", eq_width));
  debug2(("prev    "));
  print_preedit(prev_preedit);
  debug2(("\n"));
  debug2(("preedit "));
  print_preedit(preedit);
  debug2(("\n"));
#endif

  /* ץꥨǥåȤʳԽƤȤprev_preeditѹȤϥä */
  if (preedit->cursor != preedit->width || eq_width != prev_preedit->width) {
    put_cursor_invisible();
  }

  /* preedit == prev_preeditΤȤϡΰư */
  if (eq_width == preedit->width && eq_width == prev_preedit->width && eq_width > 0) {
    goto_char(preedit->cursor);
    return;
  }

  /* Ϥ֤˰ư */
  goto_col(eq_width);

  prev_end_point = width2point_col(prev_preedit->width);
  s_scroll = 0;

  /* ѤäƤʤΤѹʬ */
  if (preedit->width == prev_preedit->width) {
    int eq_width_rev = compare_preedit_rev(preedit, prev_preedit);
    struct point_tag prev_eq_rev_point = width2point_char(prev_preedit->width - eq_width_rev);
    struct point_tag eq_rev_point;
    debug2(("eq_width_rev = %d\n", eq_width_rev));
    draw_subpreedit(preedit, eq_width, preedit->width - eq_width_rev);
    eq_rev_point = width2point_char(preedit->width - eq_width_rev);
    /* eq_width_revʬ褹ɬפ뤫 */
    if (eq_rev_point.row != prev_eq_rev_point.row || eq_rev_point.col != prev_eq_rev_point.col) {
      draw_subpreedit(preedit, preedit->width - eq_width_rev, preedit->width);
      prev_end_point.row -= s_scroll;
      end_point = width2point_col(preedit->width);
      erase_area(end_point, prev_end_point);
    }
    goto_char(preedit->cursor);
    return;
  }


  draw_subpreedit(preedit, eq_width, preedit->width);

  end_point = width2point_col(preedit->width);

  /* prev_preeditõ */
  prev_end_point.row -= s_scroll;
  erase_area(end_point, prev_end_point);

  /* ΰ֤˰ư */
  goto_char(preedit->cursor);
}

/*
 * pstartμʸendʸޤǽϤ롣
 */
static void draw_subpreedit(struct preedit_tag *p, int start, int end)
{
  int i = 0;
  int w = 0;
  int byte_offset = 0;
  int width = end - start;
  int save_i;

  if (width <= 0 || p->width <= start) {
    return;
  }

  /* startɤĴ٤ */
  if (start != 0) {
    for (i = 0; i < p->nr_psegs; i++) {
      char *seg_str = p->pseg[i].str;
      int seg_w = strwidth(seg_str);
      if (w + seg_w == start) {
        i++;
        break;
      } else if (w + seg_w > start) {
        byte_offset = (width2byte(seg_str, start - w))[0];
        break;
      }
      w += seg_w;
    }
  }

  assert(i < p->nr_psegs);

  w = 0;

  save_i = i;
  p->pseg[save_i].str += byte_offset;
  for (; i < p->nr_psegs; i++) {
    char *seg_str = p->pseg[i].str;
    int seg_w = strwidth(seg_str);
    if (w + seg_w <= width) {
      draw_pseg(&(p->pseg[i]), start + w);
      w += seg_w;
      if (w == width) {
        break;
      }
    } else {
      int *byte_width = width2byte(seg_str, width - w);
      int byte = byte_width[0];
      int save_char = seg_str[byte];
      seg_str[byte] = '\0';
      draw_pseg(&(p->pseg[i]), start + w);
      seg_str[byte] = save_char;
      w += byte_width[1];
      break;
    }
  }
  p->pseg[save_i].str -= byte_offset;
}

/*
 * pseg褹
 * start_widthμʸpsegƬʸ
 */
static void draw_pseg(struct preedit_segment_tag *pseg, int start_width)
{
  struct point_tag start_point = width2point_col(start_width);
  int margin = g_win->ws_col - start_point.col;
  int lineno = start_point.row - s_head.row;
  char *seg_str = pseg->str;
  int seg_w = strwidth(seg_str);
  int total_width = start_width;
  assert(margin >= 0 && margin <= g_win->ws_col);
  debug2(("margin = %d start_point.col = %d", margin, start_point.col));
  change_attr(pseg->attr);
  /* ޤ֤ɬפ뤫 */
  while (seg_w >= margin) {
    int *byte_width = width2byte(seg_str, margin);
    int byte = byte_width[0];
    int width = byte_width[1];
    /* ޤǽ */
    put_str_len(seg_str, byte);
    /* üʸäɬפ뤫 */
    if (lineno + 1 < s_preedit_lines && s_line2width[lineno + 1] - s_line2width[lineno] > g_win->ws_col - (margin - width)) {
      put_erase(margin - width);
      change_attr(pseg->attr);
    }
    /* ץꥨǥåȤüαФȤϥ뤹 */
    if (s_head.row + lineno == g_win->ws_row - 1 && s_head.row > 0) {
      s_scroll++;
      put_crlf();
      s_head.row--;
    } else {
      put_cursor_address(s_head.row + lineno + 1, 0);
    }
    seg_str += byte;
    total_width += width;
    seg_w = strwidth(seg_str);
    /* Ԥ */
    if (lineno + 1 == s_preedit_lines) {
      s_preedit_lines++;
      s_line2width = realloc(s_line2width, sizeof(int) * s_preedit_lines);
    }
    s_line2width[lineno + 1] = total_width;
    debug2(("s_line2width[%d] = %d", lineno + 1, s_line2width[lineno + 1]));
    margin = g_win->ws_col;
    lineno++;
  }
  put_str(seg_str);
}

/*
 * °attrˤ
 */
static void change_attr(int attr)
{
  if (!(attr & UPreeditAttr_Reverse)) {
    put_exit_standout_mode();
  }
  if (!(attr & UPreeditAttr_UnderLine)) {
    put_exit_underline_mode();
  }
  if (attr & UPreeditAttr_Reverse) {
    put_enter_standout_mode();
  }
  if (attr & UPreeditAttr_UnderLine) {
    put_enter_underline_mode();
  }
}

/*
 * p1p2Ƭζʬʸ(°)֤
 */
static int compare_preedit(struct preedit_tag *p1, struct preedit_tag *p2)
{
  int i;
  int eq_width = 0;

  for (i = 0; i < min(p1->nr_psegs, p2->nr_psegs); i++) {
    struct preedit_segment_tag *pseg1 = &(p1->pseg[i]);
    struct preedit_segment_tag *pseg2 = &(p2->pseg[i]);
    if (pseg1->attr == pseg2->attr) {
      if (strcmp(pseg1->str, pseg2->str) == 0) {
        eq_width += strwidth(pseg1->str);
      } else {
        eq_width += compare_str(pseg1->str, pseg2->str);
        break;
      }
    } else {
      break;
    }
  }
  return eq_width;
}

/*
 * p1p2ζʬʸ(°)֤
 */
static int compare_preedit_rev(struct preedit_tag *p1, struct preedit_tag *p2)
{
  int i;
  int eq_width_rev = 0;

  for (i = 1; i <= min(p1->nr_psegs, p2->nr_psegs); i++) {
    struct preedit_segment_tag *pseg1 = &(p1->pseg[p1->nr_psegs - i]);
    struct preedit_segment_tag *pseg2 = &(p2->pseg[p2->nr_psegs - i]);
    if (pseg1->attr == pseg2->attr) {
      if (strcmp(pseg1->str, pseg2->str) == 0) {
        eq_width_rev += strwidth(pseg1->str);
      } else {
        eq_width_rev += compare_str_rev(pseg1->str, pseg2->str);
        break;
      }
    } else {
      break;
    }
  }
  return eq_width_rev;
}

static int min(int a, int b)
{
  return a < b ? a : b;
}

/*
 * põ
 * ϻΥ֤Ǥ
 * λΥ֤
 */
static void erase_preedit(struct preedit_tag *p)
{
  erase_area(width2point_char(0), width2point_char(p->width));
}

/*
 * startendʸޤǤõ
 * endϥץꥨǥåȤμcolumnǤʤФʤʤ
 * ϻΥ֤Ǥ
 * λΥ֤
 */
static void erase_area(struct point_tag start, struct point_tag end)
{
  int lineno = start.row - s_head.row;
  if (start.row > end.row || (start.row == end.row && start.col >= end.col)) {
    return;
  }
  put_cursor_address_p(&start);
  /* äΤ1Ԥ */
  if (start.row == end.row) {
    if (end.col == g_win->ws_col && end.col - start.col >= 3) {
      put_clear_to_end_of_line();
    } else {
      put_erase(end.col - start.col);
    }
  } else {
    int i;
    if (g_win->ws_col - start.col >= 3) {
      put_clear_to_end_of_line();
    } else {
      put_erase(g_win->ws_col - start.col);
    }
    for (i = start.row + 1; i < end.row; i++) {
      put_cursor_address(i, 0);
      put_clear_to_end_of_line();
    }
    if (end.col != 0) {
      put_cursor_address(end.row, 0);
      if (end.col == g_win->ws_col) {
        put_clear_to_end_of_line();
      } else {
        put_erase(end.col);
      }
    }
  }
  if (start.col == 0 && lineno > 0 && s_line2width[lineno] - s_line2width[lineno - 1] < g_win->ws_col) {
    s_preedit_lines = lineno;
  } else {
    s_preedit_lines = lineno + 1;
  }
}

/*
 * ץꥨǥåȤwidthμʸ˰ư
 * goto_char(0) => Ƭʸ˰ư
 */
static void goto_char(int width)
{
  struct point_tag dest = width2point_char(width);
  assert(width >= 0);
  assert(s_preedit_lines > 0);
  put_cursor_address(dest.row, dest.col);
}

/*
 * ץꥨǥåȤwidthμcolumn˰ư
 * goto_col(0) => Ƭ˰ư
 */
static void goto_col(int width)
{
  struct point_tag dest = width2point_col(width);
  assert(width >= 0);
  assert(s_preedit_lines > 0);
  put_cursor_address(dest.row, dest.col);
}

/*
 * ץꥨǥåȤwidthμʸ°ֹ֤
 * ֹ0Ϥޤ
 */
static int width2lineno_char(int width)
{
  int i;
  assert(s_preedit_lines > 0);
  for (i = 0; i < s_preedit_lines; i++) {
    if (width < s_line2width[i]) {
      break;
    }
  }
  return i - 1;
}

/*
 * ץꥨǥåȤwidthμcolumn°ֹ֤
 * ֹ0Ϥޤ
 */
static int width2lineno_col(int width)
{
  int i;
  for (i = 0; i < s_preedit_lines; i++) {
    if (width < s_line2width[i] + g_win->ws_col) {
      return i;
    }
  }
  /* üѹ줿ȤϤˤ뤳Ȥ⤢ */
  assert(s_winch);
  return s_preedit_lines;
}

/*
 * ץꥨǥåȤwidthμʸΰ֤֤
 */
static struct point_tag width2point_char(int width)
{
  struct point_tag point;
  int lineno = width2lineno_char(width);
  assert(s_preedit_lines > 0);
  point.row = s_head.row + lineno;
  point.col = width - s_line2width[lineno];
  return point;
}

/*
 * ץꥨǥåȤwidthμcolumnΰ֤֤
 */
static struct point_tag width2point_col(int width)
{
  struct point_tag point;
  int lineno = width2lineno_col(width);
  assert(s_preedit_lines > 0);
  point.row = s_head.row + lineno;
  point.col = width - s_line2width[lineno];
  return point;
}

/*
 * üѹ줿Ȥ˸Ƥ
 */
void draw_winch(void)
{
  s_winch = TRUE;
}

#if DEBUG > 2
static void print_preedit(struct preedit_tag *p)
{
  int i;
  debug2((" cursor = %d width = %d ", p->cursor, p->width));
  for (i = 0; i < p->nr_psegs; i++) {
    debug2((" under = %d rev = %d %s\t", p->pseg[i].attr & UPreeditAttr_UnderLine, p->pseg[i].attr & UPreeditAttr_Reverse, p->pseg[i].str));
  }
}
#endif
